/*
   Use this file to create a Master GST of all the non-conflicting headers
   in Include:.  The following compiler command will create the most often
   used version of the Master GST

	sc noobjname mgst=include:all.gst all.c

   Remember that you may need to make new GST's depending on your compiler
   switches used in a project.	Some switches affect the GST as well as
   your code.  For instance, if you use the UNSIGNEDCHAR switch, you will
   need to build a GST specifically for use with this model

	sc noobjname uchar mgst=include:all_u.gst all.c
*/

#include <assert.h>
#include <ctype.h>
#include <dirent.h>
#include <dos.h>
#include <errno.h>
#include <error.h>
#include <fcntl.h>
#include <fctype.h>
#include <float.h>
#include <fork.h>
#include <functions.h>
#include <ios1.h>
#include <limits.h>
#include <locale.h>
#include <scrcntl.h>
#include <setjmp.h>
#include <signal.h>
#include <stat.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <time.h>
#include <unistd.h>
#include <datatypes/animationclass.h>
#include <datatypes/datatypes.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/pictureclass.h>
#include <datatypes/soundclass.h>
#include <datatypes/textclass.h>
#include <devices/audio.h>
#include <devices/bootblock.h>
#include <devices/cd.h>
#include <devices/clipboard.h>
#include <devices/console.h>
#include <devices/conunit.h>
#include <devices/gameport.h>
#include <devices/hardblocks.h>
#include <devices/input.h>
#include <devices/inputevent.h>
#include <devices/keyboard.h>
#include <devices/keymap.h>
#include <devices/narrator.h>
#include <devices/parallel.h>
#include <devices/printer.h>
#include <devices/prtbase.h>
#include <devices/prtgfx.h>
#include <devices/scsidisk.h>
#include <devices/serial.h>
#include <devices/timer.h>
#include <devices/trackdisk.h>
#include <diskfont/diskfont.h>
#include <diskfont/diskfonttag.h>
#include <diskfont/glyph.h>
#include <diskfont/oterrors.h>
#include <dos/datetime.h>
#include <dos/dos.h>
#include <dos/dosasl.h>
#include <dos/dosextens.h>
#include <dos/doshunks.h>
#include <dos/dostags.h>
#include <dos/exall.h>
#include <dos/filehandler.h>
#include <dos/notify.h>
#include <dos/rdargs.h>
#include <dos/record.h>
#include <dos/stdio.h>
#include <dos/var.h>
#include <exec/alerts.h>
#include <exec/devices.h>
#include <exec/errors.h>
#include <exec/exec.h>
#include <exec/execbase.h>
#include <exec/initializers.h>
#include <exec/interrupts.h>
#include <exec/io.h>
#include <exec/libraries.h>
#include <exec/lists.h>
#include <exec/memory.h>
#include <exec/nodes.h>
#include <exec/ports.h>
#include <exec/resident.h>
#include <exec/semaphores.h>
#include <exec/tasks.h>
#include <exec/types.h>
#include <gadgets/colorwheel.h>
#include <gadgets/gradientslider.h>
#include <gadgets/tapedeck.h>
#include <graphics/clip.h>
#include <graphics/coerce.h>
#include <graphics/collide.h>
#include <graphics/copper.h>
#include <graphics/display.h>
#include <graphics/displayinfo.h>
#include <graphics/gels.h>
#include <graphics/gfx.h>
#include <graphics/gfxbase.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfxnodes.h>
#include <graphics/graphint.h>
#include <graphics/layers.h>
#include <graphics/modeid.h>
#include <graphics/monitor.h>
#include <graphics/rastport.h>
#include <graphics/regions.h>
#include <graphics/rpattr.h>
#include <graphics/scale.h>
#include <graphics/sprite.h>
#include <graphics/text.h>
#include <graphics/videocontrol.h>
#include <graphics/view.h>
#include <hardware/adkbits.h>
#include <hardware/blit.h>
#include <hardware/cia.h>
#include <hardware/custom.h>
#include <hardware/dmabits.h>
#include <hardware/intbits.h>
#include <intuition/cghooks.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/gadgetclass.h>
#include <intuition/icclass.h>
#include <intuition/imageclass.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/iobsolete.h>
#include <intuition/pointerclass.h>
#include <intuition/preferences.h>
#include <intuition/screens.h>
#include <intuition/sghooks.h>
#include <libraries/amigaguide.h>
#include <libraries/asl.h>
#include <libraries/commodities.h>
#include <libraries/configregs.h>
#include <libraries/configvars.h>
#include <libraries/diskfont.h>
#include <libraries/diskfonttag.h>
#include <libraries/dos.h>
#include <libraries/dosextens.h>
#include <libraries/expansion.h>
#include <libraries/expansionbase.h>
#include <libraries/filehandler.h>
#include <libraries/gadtools.h>
#include <libraries/iffparse.h>
#include <libraries/locale.h>
#include <libraries/lowlevel.h>
#include <libraries/mathlibrary.h>
#include <libraries/mathresource.h>
#include <libraries/nonvolatile.h>
#include <libraries/realtime.h>
#include <libraries/translator.h>
#include <prefs/font.h>
#include <prefs/icontrol.h>
#include <prefs/input.h>
#include <prefs/locale.h>
#include <prefs/overscan.h>
#include <prefs/palette.h>
#include <prefs/pointer.h>
#include <prefs/prefhdr.h>
#include <prefs/printergfx.h>
#include <prefs/printerps.h>
#include <prefs/printertxt.h>
#include <prefs/screenmode.h>
#include <prefs/serial.h>
#include <prefs/sound.h>
#include <prefs/wbpattern.h>
#include <proto/amigaguide.h>
#include <proto/asl.h>
#include <proto/battclock.h>
#include <proto/battmem.h>
#include <proto/bullet.h>
#include <proto/cardres.h>
#include <proto/colorwheel.h>
#include <proto/commodities.h>
#include <proto/console.h>
#include <proto/datatypes.h>
#include <proto/disk.h>
#include <proto/diskfont.h>
#include <proto/dos.h>
#include <proto/dtclass.h>
#include <proto/exec.h>
#include <proto/expansion.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/icon.h>
#include <proto/iffparse.h>
#include <proto/input.h>
#include <proto/intuition.h>
#include <proto/keymap.h>
#include <proto/layers.h>
#include <proto/locale.h>
#include <proto/lowlevel.h>
#include <proto/misc.h>
#include <proto/nonvolatile.h>
#include <proto/potgo.h>
#include <proto/ramdrive.h>
#include <proto/realtime.h>
#include <proto/rexxsyslib.h>
#include <proto/timer.h>
#include <proto/translator.h>
#include <proto/utility.h>
#include <proto/wb.h>
#include <resources/battclock.h>
#include <resources/battmem.h>
#include <resources/battmembitsamiga.h>
#include <resources/battmembitsamix.h>
#include <resources/battmembitsshared.h>
#include <resources/card.h>
#include <resources/cia.h>
#include <resources/ciabase.h>
#include <resources/disk.h>
#include <resources/filesysres.h>
#include <resources/mathresource.h>
#include <resources/misc.h>
#include <resources/potgo.h>
#include <rexx/errors.h>
#include <rexx/rexxio.h>
#include <rexx/rxslib.h>
#include <rexx/storage.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <utility/date.h>
#include <utility/hooks.h>
#include <utility/name.h>
#include <utility/pack.h>
#include <utility/tagitem.h>
#include <utility/utility.h>
#include <workbench/icon.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>
